//David Eisenberg

import java.util.ArrayList;

public class Customer
{
	private String name;
	private Address address;
	private int accountNumber;
	public enum CustomerType{SILVER, GOLD, PLATINUM};
	private CustomerType cType = CustomerType.SILVER;
	private ArrayList<Lesson> lessonList = new ArrayList<Lesson>();

	public Customer()
	{
		setName("");
		setAddress(new Address());
		setAccountNumber(0);
	}

	public Customer(String n, Address a, int num)
	{
		setName(n);
		setAddress(a);
		setAccountNumber(num);
	}

	public void setName(String n)
	{
		name = n;
	}

	public void setAddress(Address a)
	{
		address = a;
	}

	public void setAccountNumber(int num)
	{
		accountNumber = num;
	}

	public void setCType(CustomerType c)
	{
		cType = c;
	}

	public void addLesson(Lesson l)
	{
		lessonList.add(l);
	}

	public String getName()
	{
		return name;
	}

	public Address getAddress()
	{
		return address;
	}

	public CustomerType getCType()
	{
		return cType;
	}

	public ArrayList<Lesson> getLessonList()
	{
		return lessonList;
	}

	public String toString()
	{
		return ("Name " + name + " Address" + address.toString() + "\n" + "Account Number " + accountNumber + " Customer Type " + cType + "\n");
	}

	public String getLessons()
	{

		String message = "";

		for(Lesson l : lessonList)
			message += l.toString() + "\n";

		return message;
	}

	public String createInvoice()
   	{
		double charge = 0;
		String message = "";

		if (cType == CustomerType.GOLD)
			charge +=30;
		if (cType == CustomerType.SILVER)
			charge +=25;
		if (cType == CustomerType.PLATINUM)
			charge +=35;

		for (Lesson l: lessonList)
		{
			message = getName();
			charge += l.calculateCharge(cType);
			message += " is ";
			message += String.format("$%.2f", charge);
		}

		return message;
   	}
}