//David Eisenberg

import java.io.*;
import java.util.*;
import javax.swing.*;
import java.awt.*;

public class LessonGUI extends JFrame
{
	static ArrayList<Customer> customerList = new ArrayList<Customer>();
	
	private JLabel labelName;
	private JLabel labelStreet;
	private JLabel labelCity;
	private JLabel labelState;
	private JLabel labelZip;
	private JLabel labelCType;
	private JLabel labelLType;
	private JLabel labelvChapter;
	private JLabel labelvTopic;
	private JLabel labelvNumber;
	private JLabel labeltChapter;
	private JLabel labeltTopic;
	private JLabel labeltGrade;
	private JLabel labelSubmit;

	private JTextField fieldName;
	private JTextField fieldStreet;
	private JTextField fieldCity;
	private JTextField fieldState;
	private JTextField fieldZip;
	private JTextField fieldvTopic;
	private JTextField fieldvNumber;
	private JTextField fieldtTopic;
	private JTextField fieldtGrade;

	private JRadioButton cTypeSilver;
	private JRadioButton cTypeGold;
	private JRadioButton cTypePlatinum;

	private JCheckBox videoBox;
	private JCheckBox testBox;

	private JButton submit;

	private ButtonGroup cType;
	private ButtonGroup lType;

	String vChapter[] = {"1","2","3","4","5","6","7","8","9","10"};
	String tChapter[] = {"1","2","3","4","5","6","7","8","9","10"};

	JComboBox<String> combo1 = new JComboBox<String>(vChapter);
	JComboBox<String> combo2 = new JComboBox<String>(tChapter);

	private JPanel cTypePanel;
	private JPanel lTypePanel;
	
	public LessonGUI()
	{
		super("Lesson GUI");
		setLayout(new GridLayout(14,2));

		labelName = new JLabel("Enter Name");
		labelStreet = new JLabel("Enter Street");
		labelCity = new JLabel("Enter City");
		labelState = new JLabel("Enter State");
		labelZip = new JLabel("Enter Zip");
		labelCType = new JLabel("Select Type of Customer");
		labelLType = new JLabel("Select Lesson Type");
		labelvChapter = new JLabel("Enter Video Chapter");
		labelvTopic = new JLabel("Enter Video Topic");
		labelvNumber = new JLabel("Enter Video Number");
		labeltChapter = new JLabel("Enter Test Chapter");
		labeltTopic = new JLabel("Enter Test Topic");
		labeltGrade = new JLabel("Enter Test Grade");
		labelSubmit = new JLabel("Click Submit When Done");

		fieldName = new JTextField();
		fieldStreet = new JTextField();
		fieldCity = new JTextField();
		fieldState = new JTextField();
		fieldZip = new JTextField();
		fieldvTopic = new JTextField();
		fieldvNumber = new JTextField();
		fieldtTopic = new JTextField();
		fieldtGrade = new JTextField();

		cTypeSilver = new JRadioButton("SILVER");
		cTypeGold = new JRadioButton("GOLD");
		cTypePlatinum = new JRadioButton("PLATINUM");

		videoBox = new JCheckBox("Video");
		testBox = new JCheckBox("Test");

		submit = new JButton("Submit");

		cTypePanel = new JPanel(new GridLayout(1,3));
		lTypePanel = new JPanel(new GridLayout(1,2));
		
		cType = new ButtonGroup();
		cType.add(cTypeSilver);
		cType.add(cTypeGold);
		cType.add(cTypePlatinum);
		
		lType = new ButtonGroup();
		lType.add(videoBox);
		lType.add(testBox);
		
		cTypePanel.add(cTypeSilver);
		cTypePanel.add(cTypeGold);
		cTypePanel.add(cTypePlatinum);
		
		lTypePanel.add(videoBox);
		lTypePanel.add(testBox);
		
		add(labelName);
		add(fieldName);
		add(labelStreet);
		add(fieldStreet);
		add(labelCity);
		add(fieldCity);
		add(labelState);
		add(fieldState);
		add(labelZip);
		add(fieldZip);		
		add(labelCType);
		add(cTypePanel);		
		add(labelLType);
		add(lTypePanel);
		add(labelvChapter);
		add(combo1);
		add(labelvTopic);
		add(fieldvTopic);
		add(labelvNumber);
		add(fieldvNumber);
		add(labeltChapter);
		add(combo2);
		add(labeltTopic);
		add(fieldtTopic);
		add(labeltGrade);
		add(fieldtGrade);
		add(labelSubmit);
		add(submit);
	}

	public static void readCustomers()
	{
		Scanner input;
		String name;
		String street;
		String city;
		String state;
		int zip;
		int id;
		String custtype;
		Customer c1;

		try
		{
			input = new Scanner(new File("customers.txt"));

			while(input.hasNext())
			{
				name = input.next();
				street = input.next();
				city = input.next();
				state = input.next();
				zip = input.nextInt();
				id = input.nextInt();
				custtype = input.next();
				
				c1 = new Customer(name, new Address(street, city, state, zip), id);
				customerList.add(c1);
				
				if (custtype.equals("SILVER"))
					c1.setCType(Customer.CustomerType.SILVER);
				if (custtype.equals("GOLD"))
					c1.setCType(Customer.CustomerType.GOLD);
				if (custtype.equals("PLATINUM"))
					c1.setCType(Customer.CustomerType.PLATINUM);				
			}			
		}

		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}
	}

	public static void readVideos()
	{
		Scanner input;
		String name;
		int chapter;
		String title;
		int number;
		Video v1;

		try
		{
			input = new Scanner(new File("videos.txt"));

			while(input.hasNext())
			{
				name = input.next();
				chapter = input.nextInt();
				title = input.next();
				number = input.nextInt();
				v1 = new Video(chapter,title,number);
				
				for (Customer c:customerList)
					if (c.getName().equals(name))
						c.addLesson(v1);
			}
		}

		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}
	}
	
	public static void readTests()
	{
		Scanner input;
		String name;
		int chapter;
		String topic;
		int grade;
		Test t1;
		
		try
		{
			input=new Scanner(new File("tests.txt"));
			while(input.hasNext())
			{
				name=input.next();
				chapter=input.nextInt();
				topic = input.next();
				grade=input.nextInt();
				
				t1=new Test(chapter,topic,grade);
			
				for (Customer c:customerList)
					if(c.getName().equals(name))
						c.addLesson(t1);
			}
		}	
		
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}		
	}
	
	public static void createChargeDialog()
	{
		String message = "";
		
		for (Customer c: customerList)
		{		
			message+= "This month's charge for "  + c.createInvoice()+ "\n";
			System.out.println(c + c.getLessons());		
		}
		
		JOptionPane.showMessageDialog(null,message);
	}
}