//David Eisenberg

import java.io.*;
import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class LessonGUI extends JFrame
{
	static ArrayList<Customer> customerList = new ArrayList<Customer>();
	
	private JLabel labelName;
	private JLabel labelStreet;
	private JLabel labelCity;
	private JLabel labelState;
	private JLabel labelZip;
	private JLabel labelAccountNumber;
	private JLabel labelCType;
	private JLabel labelLType;
	private JLabel labelvChapter;
	private JLabel labelvTopic;
	private JLabel labelvNumber;
	private JLabel labeltChapter;
	private JLabel labeltTopic;
	private JLabel labeltGrade;
	private JLabel labelNameForSearch;
	private JLabel labelSubmit;
	private JLabel labelFinish;

	private JTextField fieldName;
	private JTextField fieldStreet;
	private JTextField fieldCity;
	private JTextField fieldState;
	private JTextField fieldZip;
	private JTextField fieldAccountNumber;
	private JTextField fieldvTopic;
	private JTextField fieldvNumber;
	private JTextField fieldtTopic;
	private JTextField fieldtGrade;
	private JTextField fieldNameForSearch;

	private JRadioButton cTypeSilver;
	private JRadioButton cTypeGold;
	private JRadioButton cTypePlatinum;

	private JCheckBox addCustomer;
	private JCheckBox addLesson;
	private JCheckBox videoBox;
	private JCheckBox testBox;

	private JButton submit;
	private JButton finish;

	private ButtonGroup addNew;
	private ButtonGroup cType;
	private ButtonGroup lType;

	String vChapter[] = {"Select One", "1","2","3","4","5","6","7","8","9","10"};
	String tChapter[] = {"Select One", "1","2","3","4","5","6","7","8","9","10"};

	JComboBox<String> combo1 = new JComboBox<String>(vChapter);
	JComboBox<String> combo2 = new JComboBox<String>(tChapter);

	private JPanel cTypePanel;
	private JPanel lTypePanel;
	
	public LessonGUI()
	{
		super("Lesson GUI");
		setLayout(new GridLayout(18,2));

		labelName = new JLabel("Enter Name");
		labelStreet = new JLabel("Enter Street");
		labelCity = new JLabel("Enter City");
		labelState = new JLabel("Enter State");
		labelZip = new JLabel("Enter Zip");
		labelAccountNumber = new JLabel("Enter Account Number");
		labelCType = new JLabel("Select Type of Customer");
		labelLType = new JLabel("Select Lesson Type");
		labelvChapter = new JLabel("Enter Video Chapter");
		labelvTopic = new JLabel("Enter Video Topic");
		labelvNumber = new JLabel("Enter Video Number");
		labeltChapter = new JLabel("Enter Test Chapter");
		labeltTopic = new JLabel("Enter Test Topic");
		labeltGrade = new JLabel("Enter Test Grade");
		labelNameForSearch = new JLabel("Enter name for search");
		labelSubmit = new JLabel("Click Submit When Done");
		labelFinish = new JLabel("Click When Finished");

		fieldName = new JTextField();
		fieldStreet = new JTextField();
		fieldCity = new JTextField();
		fieldState = new JTextField();
		fieldZip = new JTextField(5);
		fieldZip.setToolTipText("Enter an Integer");
		fieldAccountNumber = new JTextField();
		fieldAccountNumber.setToolTipText("Enter an Integer");
		fieldvTopic = new JTextField();
		fieldvNumber = new JTextField();
		fieldvNumber.setToolTipText("Enter an Integer");
		fieldtTopic = new JTextField();
		fieldtGrade = new JTextField();
		fieldtGrade.setToolTipText("Enter an Integer");
		fieldNameForSearch = new JTextField();

		cTypeSilver = new JRadioButton("SILVER");
		cTypeGold = new JRadioButton("GOLD");
		cTypePlatinum = new JRadioButton("PLATINUM");

		addCustomer = new JCheckBox("Add Customer");
		addLesson = new JCheckBox("Add Lesson");
		videoBox = new JCheckBox("Video");
		testBox = new JCheckBox("Test");

		submit = new JButton("Submit");
		finish = new JButton("Finish");

		cTypePanel = new JPanel(new GridLayout(1,3));
		lTypePanel = new JPanel(new GridLayout(1,2));
		
		addNew = new ButtonGroup();
		addNew.add(addCustomer);
		addNew.add(addLesson);
		
		cType = new ButtonGroup();
		cType.add(cTypeSilver);
		cType.add(cTypeGold);
		cType.add(cTypePlatinum);
		
		lType = new ButtonGroup();
		lType.add(videoBox);
		lType.add(testBox);
		
		cTypePanel.add(cTypeSilver);
		cTypePanel.add(cTypeGold);
		cTypePanel.add(cTypePlatinum);
		
		lTypePanel.add(videoBox);
		lTypePanel.add(testBox);
		
		addCustomer.addItemListener(new ItemListener()
		{
			public void itemStateChanged(ItemEvent e)
			{
				if(e.getStateChange() == ItemEvent.SELECTED)
				{
					fieldvTopic.setEnabled(false);
					fieldvNumber.setEnabled(false);
					fieldtTopic.setEnabled(false);
					fieldtGrade.setEnabled(false);
					videoBox.setEnabled(false);
					testBox.setEnabled(false);
					combo1.setEnabled(false);
					combo2.setEnabled(false);
					fieldNameForSearch.setEnabled(false);
				}
				else
				{
					fieldvTopic.setEnabled(true);
					fieldvNumber.setEnabled(true);
					fieldtTopic.setEnabled(true);
					fieldtGrade.setEnabled(true);
					videoBox.setEnabled(true);
					testBox.setEnabled(true);
					combo1.setEnabled(true);
					combo2.setEnabled(true);
				}
			}
		});
		
		addLesson.addItemListener(new ItemListener()
		{
			public void itemStateChanged(ItemEvent e)
			{
				if(e.getStateChange() == ItemEvent.SELECTED)
				{
					fieldStreet.setEnabled(false);
					fieldCity.setEnabled(false);
					fieldState.setEnabled(false);
					fieldZip.setEnabled(false);
					fieldAccountNumber.setEnabled(false);
					cTypeSilver.setEnabled(false);
					cTypeGold.setEnabled(false);
					cTypePlatinum.setEnabled(false);
					fieldNameForSearch.setEnabled(false);
					
				}
				else
				{
					fieldStreet.setEnabled(true);
					fieldCity.setEnabled(true);
					fieldState.setEnabled(true);
					fieldZip.setEnabled(true);
					fieldAccountNumber.setEnabled(true);
					cTypeSilver.setEnabled(true);
					cTypeGold.setEnabled(true);
					cTypePlatinum.setEnabled(true);
				}
			}
		});
		
		videoBox.addItemListener(new ItemListener()
		{
			public void itemStateChanged(ItemEvent e)
			{
				if(e.getStateChange() == ItemEvent.SELECTED)
				{
					fieldtTopic.setEnabled(false);
					fieldtGrade.setEnabled(false);
					combo2.setEnabled(false);
				}
				else
				{
					fieldtTopic.setEnabled(true);
					fieldtGrade.setEnabled(true);
					combo2.setEnabled(true);
				}
			}
		});
		
		testBox.addItemListener(new ItemListener()
		{
			public void itemStateChanged(ItemEvent e)
			{
				if(e.getStateChange() == ItemEvent.SELECTED)
				{
					fieldvTopic.setEnabled(false);
					fieldvNumber.setEnabled(false);
					combo1.setEnabled(false);
				}
				else
				{
					fieldvTopic.setEnabled(true);
					fieldvNumber.setEnabled(true);
					combo1.setEnabled(true);
				}
			}
		});
				
		ButtonHandler1 handlerSubmit = new ButtonHandler1();
		submit.addActionListener(handlerSubmit);
		
		ButtonHandler2 handlerFinish = new ButtonHandler2();
		finish.addActionListener(handlerFinish);
		
		add(addCustomer);
		add(addLesson);
		add(labelName);
		add(fieldName);
		add(labelStreet);
		add(fieldStreet);
		add(labelCity);
		add(fieldCity);
		add(labelState);
		add(fieldState);
		add(labelZip);
		add(fieldZip);	
		add(labelAccountNumber);
		add(fieldAccountNumber);
		add(labelCType);
		add(cTypePanel);		
		add(labelLType);
		add(lTypePanel);
		add(labelvChapter);
		add(combo1);
		add(labelvTopic);
		add(fieldvTopic);
		add(labelvNumber);
		add(fieldvNumber);
		add(labeltChapter);
		add(combo2);
		add(labeltTopic);
		add(fieldtTopic);
		add(labeltGrade);
		add(fieldtGrade);
		add(labelNameForSearch);
		add(fieldNameForSearch);
		add(labelSubmit);
		add(submit);
		add(labelFinish);
		add(finish);
	}
	
	public void clearAll()
	{
		addNew.clearSelection();
		fieldName.setText("");
		fieldStreet.setText("");
		fieldCity.setText("");
		fieldState.setText("");
		fieldZip.setText("");
		fieldAccountNumber.setText("");
		cType.clearSelection();
		lType.clearSelection();
		combo1.setSelectedIndex(0);
		fieldvTopic.setText("");
		fieldvNumber.setText("");
		combo2.setSelectedIndex(0);
		fieldtTopic.setText("");
		fieldtGrade.setText("");
		fieldNameForSearch.setText("");
		fieldNameForSearch.setEnabled(true);
		fieldName.requestFocus();
	}
	
	public boolean checkData()
	{
		boolean input = true;
		
		if ((!addCustomer.isSelected() && !addLesson.isSelected()) && fieldNameForSearch.getText().isEmpty())
		{
			JOptionPane.showMessageDialog(null, "Please choose to either add a customer, a lesson, or type a name to search for.");
			clearAll();
			input = false;
		}
		else if (addCustomer.isSelected() && fieldNameForSearch.getText().isEmpty())
		{
			if (fieldName.getText().isEmpty())
			{
				JOptionPane.showMessageDialog(null, "Please enter a name.");
				fieldName.setText("");
				fieldName.requestFocus();
				input = false;
			}
			
			else if (fieldStreet.getText().isEmpty())
			{
				JOptionPane.showMessageDialog(null, "Please enter a street.");
				fieldStreet.setText("");
				fieldStreet.requestFocus();
				input = false;
			}
			
			else if (fieldCity.getText().isEmpty())
			{
				JOptionPane.showMessageDialog(null, "Please enter a city.");
				fieldCity.setText("");
				fieldCity.requestFocus();
				input = false;
			}
			
			else if (fieldState.getText().isEmpty())
			{
				JOptionPane.showMessageDialog(null, "Please enter a state.");
				fieldState.setText("");
				fieldState.requestFocus();
				input = false;
			}
			
			else if (fieldZip.getText().isEmpty() || !isInt(fieldZip.getText()))
			{
				JOptionPane.showMessageDialog(null, "Please enter an integer zip code.");
				fieldZip.setText("");
				fieldZip.requestFocus();
				input = false;
			}
			
			else if (fieldAccountNumber.getText().isEmpty() || !isInt(fieldAccountNumber.getText()))
			{
				JOptionPane.showMessageDialog(null, "Please enter an integer account number.");
				fieldAccountNumber.setText("");
				fieldAccountNumber.requestFocus();
				input = false;
			}
			
			else if (!cTypeSilver.isSelected() && !cTypeGold.isSelected() && !cTypePlatinum.isSelected())
			{
				JOptionPane.showMessageDialog(null, "Please select a customer type.");
				cTypeSilver.requestFocus();
				input = false;
			}		
		}
		
		else if (addLesson.isSelected() && fieldNameForSearch.getText().isEmpty())
		{
			if (fieldName.getText().isEmpty())
			{
				JOptionPane.showMessageDialog(null, "Please enter a name.");
				fieldName.setText("");
				fieldName.requestFocus();
				input = false;
			}
			
			else if(!videoBox.isSelected() && !testBox.isSelected())
			{
				videoBox.requestFocus();
				JOptionPane.showMessageDialog(null, "Please select the video or test checkbox.");
				input = false;
			}
			
			else if(videoBox.isSelected())
			{
				if (combo1.getSelectedIndex() == 0)
				{
					JOptionPane.showMessageDialog(null, "Select a video chapter from the drop down box.");
					combo1.setSelectedIndex(0);
					input = false;
				}
			
				else if (fieldvTopic.getText().isEmpty())
				{
					JOptionPane.showMessageDialog(null, "Please enter a topic.");
					fieldvTopic.setText("");
					fieldvTopic.requestFocus();
					input = false;
				}
				
				else if (fieldvNumber.getText().isEmpty() || !isInt(fieldvNumber.getText()))
				{
					JOptionPane.showMessageDialog(null, "Please enter an integer video number.");
					fieldvNumber.setText("");
					fieldvNumber.requestFocus();
					input = false;
				}
			}
			
			else if(testBox.isSelected())
			{
				if (combo2.getSelectedIndex() == 0)
				{
					JOptionPane.showMessageDialog(null, "Select a test chapter from the drop down box.");
					combo2.setSelectedIndex(0);
					input = false;
				}
			
				else if (fieldtTopic.getText().isEmpty())
				{
					JOptionPane.showMessageDialog(null, "Please enter a topic.");
					fieldtTopic.setText("");
					fieldtTopic.requestFocus();
					input = false;
				}
				
				else if (fieldtGrade.getText().isEmpty() || !isInt(fieldtGrade.getText()))
				{
					JOptionPane.showMessageDialog(null, "Please enter an integer test grade.");
					fieldtGrade.setText("");
					fieldtGrade.requestFocus();
					input = false;
				}
			}
		}	
		return input;
	}

	public boolean searchName(String s) throws NameNotFoundException
	{
		boolean input = false;
		String message = "";
		
		for (Customer c : customerList)
		{
			if (c.getName().equals(s))
			{
				message += c.toString() + "\n";
				
				if (c.getLessons().equals(""))
				{
					message += "No lessons were entered." + "\n";
					message += "Feel free to go back and add some lessons." + "\n";
				}
				else
				{
					message += c.getLessons() + "\n";
					message += "This month's charge for "  + c.createInvoice()+ "\n";
				}
				
				JOptionPane.showMessageDialog(null, message);
				input = true;
			}
		}
		
		if(!input)
			throw new NameNotFoundException();
		else
			return input;
	}
	
	class NameNotFoundException extends RuntimeException
	{
		public NameNotFoundException()
		{
			super("Unable to find customer name.");
		}
	}
	
	class ButtonHandler1 implements ActionListener
	{
		public void actionPerformed (ActionEvent ae)
		{
			if(checkData())
			{
				if (addCustomer.isSelected())
				{
		
					String name;
					String street;
					String city;
					String state;
					int zip;
					int id;
					String custtype;
					Customer c1;		
							
					{
						name = fieldName.getText();
						street = fieldStreet.getText();
						city = fieldCity.getText();
						state = fieldState.getText();
						zip = Integer.parseInt(fieldZip.getText());
						id = Integer.parseInt(fieldAccountNumber.getText());
						
						c1 = new Customer(name, new Address(street, city, state, zip), id);
						customerList.add(c1);
						
						if (cTypeSilver.isSelected())
							c1.setCType(Customer.CustomerType.SILVER);
						if (cTypeGold.isSelected())
							c1.setCType(Customer.CustomerType.GOLD);
						if (cTypePlatinum.isSelected())
							c1.setCType(Customer.CustomerType.PLATINUM);				
					}			

				}
				else if (addLesson.isSelected())
				{
					if (videoBox.isSelected())
					{
						String name;
						String chapter;
						int chapterconvert;
						String title;
						int number;
						Video v1;
						
						name = fieldName.getText();
						chapter = vChapter[combo1.getSelectedIndex()];
						title = fieldvTopic.getText();
						number = Integer.parseInt(fieldvNumber.getText());
						chapterconvert = Integer.parseInt(chapter);
						
						v1 = new Video(chapterconvert,title,number);
				
						for (Customer c:customerList)
						{	
							if (c.getName().equals(name))
								c.addLesson(v1);
						}
					}
				
					if (testBox.isSelected())
					{
						String name;
						String chapter;
						int chapterconvert;
						String title;
						int grade;
						Test t1;
						
						name = fieldName.getText();
						chapter = tChapter[combo2.getSelectedIndex()];
						title = fieldtTopic.getText();
						grade = Integer.parseInt(fieldtGrade.getText());
						chapterconvert = Integer.parseInt(chapter);
						
						t1 = new Test(chapterconvert,title,grade);
				
						for (Customer c:customerList)
						{
							if (c.getName().equals(name))
								c.addLesson(t1);
						}
					}
				}
				else if (!fieldNameForSearch.getText().isEmpty())
				{
					try
					{
						searchName(fieldNameForSearch.getText());
					}
					catch(NameNotFoundException nnfe)
					{
						JOptionPane.showMessageDialog(null, "The search found no results. Make sure you type the name exactly how you entered it in, entry is case sensitive ie: Smith instead of smith.");
					}
				}
				
				clearAll();
			}
		}				
	}
		
	class ButtonHandler2 implements ActionListener
	{
		public void actionPerformed (ActionEvent ae)
		{
			ObjectOutputStream output;
			try
			{
				output = new ObjectOutputStream (new FileOutputStream("customers.ser"));
				
				for(Customer c: customerList)
					output.writeObject(c);
					
				System.exit(0);
			}
			
			catch(IOException ioe)
			{
				ioe.printStackTrace();
			}
		}
	}
	
	public boolean isInt(String s)
	{
		try
		{
			Integer.parseInt(s);
			return true;
		}
		catch(NumberFormatException nfe)
		{
			return false;
		}
	}	
	
	public static void readCustomers()
	{
		Scanner input;
		String name;
		String street;
		String city;
		String state;
		int zip;
		int id;
		String custtype;
		Customer c1;

		try
		{
			input = new Scanner(new File("customers.txt"));

			while(input.hasNext())
			{
				name = input.next();
				street = input.next();
				city = input.next();
				state = input.next();
				zip = input.nextInt();
				id = input.nextInt();
				custtype = input.next();
				
				c1 = new Customer(name, new Address(street, city, state, zip), id);
				customerList.add(c1);
				
				if (custtype.equals("SILVER"))
					c1.setCType(Customer.CustomerType.SILVER);
				if (custtype.equals("GOLD"))
					c1.setCType(Customer.CustomerType.GOLD);
				if (custtype.equals("PLATINUM"))
					c1.setCType(Customer.CustomerType.PLATINUM);				
			}			
		}

		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}
	}

	public static void readVideos()
	{
		Scanner input;
		String name;
		int chapter;
		String title;
		int number;
		Video v1;

		try
		{
			input = new Scanner(new File("videos.txt"));

			while(input.hasNext())
			{
				name = input.next();
				chapter = input.nextInt();
				title = input.next();
				number = input.nextInt();
				v1 = new Video(chapter,title,number);
				
				for (Customer c:customerList)
					if (c.getName().equals(name))
						c.addLesson(v1);
			}
		}

		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}
	}
	
	public static void readTests()
	{
		Scanner input;
		String name;
		int chapter;
		String topic;
		int grade;
		Test t1;
		
		try
		{
			input=new Scanner(new File("tests.txt"));
			while(input.hasNext())
			{
				name=input.next();
				chapter=input.nextInt();
				topic = input.next();
				grade=input.nextInt();
				
				t1=new Test(chapter,topic,grade);
			
				for (Customer c:customerList)
					if(c.getName().equals(name))
						c.addLesson(t1);
			}
		}	
		
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}		
	}
	
	public static void createChargeDialog()
	{
		String message = "";
		
		for (Customer c: customerList)
		{		
			message+= "This month's charge for "  + c.createInvoice()+ "\n";
			System.out.println(c + c.getLessons());		
		}
		
		JOptionPane.showMessageDialog(null,message);
	}
}