//David Eisenberg

import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.util.*;
import java.awt.*;

public class AddCustomerPanel extends JPanel
{
	static ArrayList<Customer> customerList = new ArrayList<Customer>();
	private JLabel labelName;
	private JLabel labelStreet;
	private JLabel labelCity;
	private JLabel labelState;
	private JLabel labelZip;
	private JLabel labelAccountNumber;
	private JLabel labelCType;
	private JLabel labelSubmit;
	private JTextField fieldName;
	private JTextField fieldStreet;
	private JTextField fieldCity;
	private JTextField fieldState;
	private JTextField fieldZip;
	private JTextField fieldAccountNumber;
	private JRadioButton cTypeSilver;
	private JRadioButton cTypeGold;
	private JRadioButton cTypePlatinum;
	private JCheckBox videoBox;
	private JCheckBox testBox;
	private JButton submit;
	private ButtonGroup cType;
	private JPanel cTypePanel;
	
	public AddCustomerPanel()
	{
		setLayout(new GridLayout(8,2));
	
		labelName = new JLabel("Enter Name");
		labelStreet = new JLabel("Enter Street");
		labelCity = new JLabel("Enter City");
		labelState = new JLabel("Enter State");
		labelZip = new JLabel("Enter Zip");
		labelAccountNumber = new JLabel("Enter Account Number");
		labelCType = new JLabel("Select Type of Customer");
		labelSubmit = new JLabel("Click Submit When Done");
		fieldName = new JTextField();
		fieldStreet = new JTextField();
		fieldCity = new JTextField();
		fieldState = new JTextField();
		fieldZip = new JTextField(5);
		fieldZip.setToolTipText("Enter an Integer");
		fieldAccountNumber = new JTextField();
		fieldAccountNumber.setToolTipText("Enter an Integer");
		cTypeSilver = new JRadioButton("SILVER");
		cTypeGold = new JRadioButton("GOLD");
		cTypePlatinum = new JRadioButton("PLATINUM");
		submit = new JButton("Submit");
		cTypePanel = new JPanel(new GridLayout(1,3));
		cType = new ButtonGroup();
		cType.add(cTypeSilver);
		cType.add(cTypeGold);
		cType.add(cTypePlatinum);
		cTypePanel.add(cTypeSilver);
		cTypePanel.add(cTypeGold);
		cTypePanel.add(cTypePlatinum);
		
		ButtonHandler1 handlerSubmit = new ButtonHandler1();
		submit.addActionListener(handlerSubmit);
		
		add(labelName);
		add(fieldName);
		add(labelStreet);
		add(fieldStreet);
		add(labelCity);
		add(fieldCity);
		add(labelState);
		add(fieldState);
		add(labelZip);
		add(fieldZip);	
		add(labelAccountNumber);
		add(fieldAccountNumber);
		add(labelCType);
		add(cTypePanel);		
		add(labelSubmit);
		add(submit);
	}
	
	public void clearAll()
	{
		fieldName.setText("");
		fieldStreet.setText("");
		fieldCity.setText("");
		fieldState.setText("");
		fieldZip.setText("");
		fieldAccountNumber.setText("");
		cType.clearSelection();
		fieldName.requestFocus();
	}
	
	public boolean checkData()
	{
		boolean input = true;

		if (fieldName.getText().isEmpty())
		{
			JOptionPane.showMessageDialog(null, "Please enter a name.");
			fieldName.setText("");
			fieldName.requestFocus();
			input = false;
		}
		
		else if (fieldStreet.getText().isEmpty())
		{
			JOptionPane.showMessageDialog(null, "Please enter a street.");
			fieldStreet.setText("");
			fieldStreet.requestFocus();
			input = false;
		}
		
		else if (fieldCity.getText().isEmpty())
		{
			JOptionPane.showMessageDialog(null, "Please enter a city.");
			fieldCity.setText("");
			fieldCity.requestFocus();
			input = false;
		}
		
		else if (fieldState.getText().isEmpty())
		{
			JOptionPane.showMessageDialog(null, "Please enter a state.");
			fieldState.setText("");
			fieldState.requestFocus();
			input = false;
		}
		
		else if (fieldZip.getText().isEmpty() || !isInt(fieldZip.getText()))
		{
			JOptionPane.showMessageDialog(null, "Please enter an integer zip code.");
			fieldZip.setText("");
			fieldZip.requestFocus();
			input = false;
		}
		
		else if (fieldAccountNumber.getText().isEmpty() || !isInt(fieldAccountNumber.getText()))
		{
			JOptionPane.showMessageDialog(null, "Please enter an integer account number.");
			fieldAccountNumber.setText("");
			fieldAccountNumber.requestFocus();
			input = false;
		}
		
		else if (!cTypeSilver.isSelected() && !cTypeGold.isSelected() && !cTypePlatinum.isSelected())
		{
			JOptionPane.showMessageDialog(null, "Please select a customer type.");
			cTypeSilver.requestFocus();
			input = false;
		}
		
		return input;
	}
	
	class ButtonHandler1 implements ActionListener
	{
		public void actionPerformed (ActionEvent ae)
		{
			if(checkData())
			{		
				String name;
				String street;
				String city;
				String state;
				int zip;
				int id;
				String custtype = "";
						
				{
					name = fieldName.getText();
					street = fieldStreet.getText();
					city = fieldCity.getText();
					state = fieldState.getText();
					zip = Integer.parseInt(fieldZip.getText());
					id = Integer.parseInt(fieldAccountNumber.getText());
										
					if (cTypeSilver.isSelected())
						custtype = "SILVER";
					if (cTypeGold.isSelected())
						custtype = "GOLD";
					if (cTypePlatinum.isSelected())
						custtype = "PLATINUM";
						
					DatabaseMethods dm1 = new DatabaseMethods();
					dm1.addCustomer(name, street, city, state, zip, id, custtype);			
				}			
				
				clearAll();
			}
		}				
	}
	
	public boolean isInt(String s)
	{
		try
		{
			Integer.parseInt(s);
			return true;
		}
		catch(NumberFormatException nfe)
		{
			return false;
		}
	}	
}