//David Eisenberg

import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.util.*;
import java.awt.*;

public class AddVideoPanel extends JPanel
{
	static ArrayList<Customer> customerList = new ArrayList<Customer>();
	private JLabel labelName;
	private JLabel labelvChapter;
	private JLabel labelvTopic;
	private JLabel labelvNumber;
	private JLabel labelSubmit;
	private JTextField fieldName;
	private JTextField fieldvTopic;
	private JTextField fieldvNumber;
	private JButton submit;
	String vChapter[] = {"Select One", "1","2","3","4","5","6","7","8","9","10"};
	JComboBox<String> combo1 = new JComboBox<String>(vChapter);
	
	public AddVideoPanel()
	{
		setLayout(new GridLayout(5,2));
		
		labelName = new JLabel("Enter Name");
		labelvChapter = new JLabel("Enter Video Chapter");
		labelvTopic = new JLabel("Enter Video Topic");
		labelvNumber = new JLabel("Enter Video Number");
		labelSubmit = new JLabel("Click Submit When Done");
		fieldName = new JTextField();
		fieldvTopic = new JTextField();
		fieldvNumber = new JTextField();
		fieldvNumber.setToolTipText("Enter an Integer");
		submit = new JButton("Submit");
		
		ButtonHandler1 handlerSubmit = new ButtonHandler1();
		submit.addActionListener(handlerSubmit);
		
		add(labelName);
		add(fieldName);
		add(labelvChapter);
		add(combo1);
		add(labelvTopic);
		add(fieldvTopic);
		add(labelvNumber);
		add(fieldvNumber);
		add(labelSubmit);
		add(submit);
	}
	
	public boolean isInt(String s)
	{
		try
		{
			Integer.parseInt(s);
			return true;
		}
		catch(NumberFormatException nfe)
		{
			return false;
		}
	}

	class ButtonHandler1 implements ActionListener
	{
		public void actionPerformed (ActionEvent ae)
		{
			if(checkData())
			{	
				String name;
				String chapter;
				int chapterconvert;
				String title;
				int number;
				Video v1;
				
				name = fieldName.getText();
				chapter = vChapter[combo1.getSelectedIndex()];
				title = fieldvTopic.getText();
				number = Integer.parseInt(fieldvNumber.getText());
				chapterconvert = Integer.parseInt(chapter);
				
				DatabaseMethods dm3 = new DatabaseMethods();
				dm3.addVideo(name, chapterconvert, title, number);
			}
		
			clearAll();
		}	
	}
	
	public boolean checkData()
	{
		boolean input = true;
		
		if (fieldName.getText().isEmpty())
		{
			JOptionPane.showMessageDialog(null, "Please enter a name.");
			fieldName.setText("");
			fieldName.requestFocus();
			input = false;
		}
		
		else if (combo1.getSelectedIndex() == 0)
		{
			JOptionPane.showMessageDialog(null, "Select a video chapter from the drop down box.");
			combo1.setSelectedIndex(0);
			input = false;
		}
		
		else if (fieldvTopic.getText().isEmpty())
		{
			JOptionPane.showMessageDialog(null, "Please enter a topic.");
			fieldvTopic.setText("");
			fieldvTopic.requestFocus();
			input = false;
		}
			
		else if (fieldvNumber.getText().isEmpty() || !isInt(fieldvNumber.getText()))
		{
			JOptionPane.showMessageDialog(null, "Please enter an integer video number.");
			fieldvNumber.setText("");
			fieldvNumber.requestFocus();
			input = false;
		}
		
		return input;
	}
	
	public void clearAll()
	{
		fieldName.setText("");
		combo1.setSelectedIndex(0);
		fieldvTopic.setText("");
		fieldvNumber.setText("");	
		fieldName.requestFocus();
	}
}