//David Eisenberg

import java.sql.*;
import java.util.*;
import javax.swing.*;
import java.io.*;
import java.awt.event.*;

public class DatabaseMethods
{                           
	private static final String URL = "jdbc:mysql://localhost/customers";
	private static final String USERNAME = "deitel";
	private static final String PASSWORD = "deitel";
	private static ArrayList<Customer> customerList = new ArrayList<Customer>();

	private Connection connection = null;
	private Statement statement = null;
	private ResultSet resultSet = null;
	private ResultSet resultSetTest = null;
	private ResultSet resultSetVideo = null;
	private ResultSet resultSearch = null;
	private PreparedStatement addNewCustomer = null;
	private PreparedStatement addNewTest = null;
	private PreparedStatement addNewVideo = null;
	private PreparedStatement searchCustomers = null;
	private PreparedStatement searchTest = null;
	private PreparedStatement searchVideo = null;
	private PreparedStatement search = null;
	
	public DatabaseMethods()
	{
		try
		{
			connection = DriverManager.getConnection(URL, USERNAME, PASSWORD);
			
			addNewCustomer = connection.prepareStatement("INSERT INTO Customer" + "(Customer, Street, City, State, ZipCode, Account, Type)" + "VALUES (?,?,?,?,?,?,?)");
			addNewTest = connection.prepareStatement("INSERT INTO Test" + "(CustomerName, Chapter, Title, Grade)" + "VALUES (?,?,?,?)");
			addNewVideo = connection.prepareStatement("INSERT INTO Video" + "(CustomerName, Chapter, Title, ID)" + "VALUES (?,?,?,?)");
			searchCustomers = connection.prepareStatement("SELECT * FROM Customer WHERE Customer = ?");
			searchTest = connection.prepareStatement("SELECT * FROM Test WHERE CustomerName = ?");
			searchVideo = connection.prepareStatement("SELECT * FROM Video WHERE CustomerName = ?");
			search = connection.prepareStatement("SELECT * FROM Customer WHERE Customer = ?");
		}
		catch (SQLException sqlException)
		{
			sqlException.printStackTrace();
			System.exit(1);
		}
	}   
   
	public int addCustomer(String name, String street, String city, String state, int zip, int account, String type)
	{
		int result = 0;
		
		try 
		{
			addNewCustomer.setString( 1, name );
			addNewCustomer.setString( 2, street );
			addNewCustomer.setString( 3, city );
			addNewCustomer.setString( 4, state );
			addNewCustomer.setInt(5, zip);
			addNewCustomer.setInt(6, account);
			addNewCustomer.setString(7, type);
			
			result = addNewCustomer.executeUpdate(); 
		}
		catch(SQLException sqlException)
		{
			sqlException.printStackTrace();
		}
      
		return result;
	}
	
	public int addTest(String name, int chapter, String title, int grade)
	{
		int result = 0;
		
		try
		{
			addNewTest.setString(1, name);
			addNewTest.setInt(2, chapter);
			addNewTest.setString(3, title);
			addNewTest.setInt(4, grade);
			
			result = addNewTest.executeUpdate();
		}
		catch(SQLException sqlException)
		{
			sqlException.printStackTrace();
		}
		
		return result;
	}
	
	public int addVideo (String name, int chapter, String title, int ID)
	{
		int result = 0;
		
		try
		{
			addNewVideo.setString(1, name);
			addNewVideo.setInt(2, chapter);
			addNewVideo.setString(3, title);
			addNewVideo.setInt(4, ID);
			
			result = addNewVideo.executeUpdate();
		}
		
		catch(SQLException sqlException)
		{
			sqlException.printStackTrace();
		}
		
		return result;
	}
	public void writeCustomerTable()
	{  
		try 
		{
			statement = connection.createStatement();
			resultSet = statement.executeQuery("SELECT * from Customer ORDER BY Customer ASC" );
			ResultSetMetaData metaData = resultSet.getMetaData();
			int numberOfColumns = metaData.getColumnCount();     
			System.out.println( "Customers in the Customer Table:\n" );
         
			for ( int i = 1; i <= numberOfColumns; i++ )
				System.out.printf( "%-10s ", metaData.getColumnName( i ) );
			System.out.println();
         
			while ( resultSet.next() ) 
			{
				for ( int i = 1; i <= numberOfColumns; i++ )
					System.out.printf( "%-10s ", resultSet.getObject( i ) );
				System.out.println();
			}
		}
		catch ( SQLException sqlException )                                
		{                                                                  
			sqlException.printStackTrace();
		}                                                   
		finally
		{                                                             
			try                                                        
			{                                                          
				resultSet.close();                                      
				statement.close();                                      
			}                                              
			catch ( Exception exception )                              
			{                                                          
				exception.printStackTrace();                            
			}                                              
		}                                          
	} 
	
	public void writeVideoTable()
	{  
		try 
		{
			statement = connection.createStatement();
			resultSet = statement.executeQuery("SELECT * from Video ORDER BY Chapter ASC" );
			ResultSetMetaData metaData = resultSet.getMetaData();
			int numberOfColumns = metaData.getColumnCount();     
			System.out.println( "Video Lessons in the Video Table:\n" );
         
			for ( int i = 1; i <= numberOfColumns; i++ )
				System.out.printf( "%-8s\t", metaData.getColumnName( i ) );
			System.out.println();
         
			while ( resultSet.next() ) 
			{
				for ( int i = 1; i <= numberOfColumns; i++ )
					System.out.printf( "%-8s\t", resultSet.getObject( i ) );
				System.out.println();
			}
		}
		catch ( SQLException sqlException )                                
		{                                                                  
			sqlException.printStackTrace();
		}                                                   
		finally
		{                                                             
			try                                                        
			{                                                          
				resultSet.close();                                      
				statement.close();                                     
			}                                              
			catch ( Exception exception )                              
			{                                                          
				exception.printStackTrace();                            
			}                                              
		}                                          
	} 
	
	public void writeTestTable()
	{  
		try 
		{
			statement = connection.createStatement();
			resultSet = statement.executeQuery("SELECT * from Test ORDER BY Chapter ASC" );
			ResultSetMetaData metaData = resultSet.getMetaData();
			int numberOfColumns = metaData.getColumnCount();     
			System.out.println( "Tests in the Test Table:\n" );
         
			for ( int i = 1; i <= numberOfColumns; i++ )
				System.out.printf( "%-8s\t", metaData.getColumnName( i ) );
			System.out.println();
         
			while ( resultSet.next() ) 
			{
				for ( int i = 1; i <= numberOfColumns; i++ )
					System.out.printf( "%-8s\t", resultSet.getObject( i ) );
				System.out.println();
			}
		}
		catch ( SQLException sqlException )                                
		{                                                                  
			sqlException.printStackTrace();
		}                                                   
		finally
		{                                                             
			try                                                        
			{                                                          
				resultSet.close();                                      
				statement.close();                                      
			}                                              
			catch ( Exception exception )                              
			{                                                          
				exception.printStackTrace();                            
			}                                              
		}                                          
	}
	
	public boolean searchName(String s) throws NameNotFoundException
	{
		boolean input = false;
		String check;
		
		try
		{
			search.setString(1, s);
			resultSearch = search.executeQuery();
			while(resultSearch.next())
			{
			check = resultSearch.getString("customer");
			
			if (check.equals(s))
			{

				input = true;
			}
			else
				input = false;
			}
		}
		catch(SQLException sqlException)
		{
			sqlException.printStackTrace();
		}
		/*finally
		{
			try
			{
				resultSearch.close();
			}
			catch(SQLException sqlException)
			{
				sqlException.printStackTrace();
				close();
			}
		}*/
		if (!input)
			throw new NameNotFoundException();
		else
			return input;
	}
		

	public List<Customer> searchDatabase(String name)
	{
		List<Customer> results = null;
		ResultSet resultSet = null;
		
		try
		{
			searchCustomers.setString(1, name);
			searchTest.setString(1, name);
			searchVideo.setString(1, name);
			resultSet = searchCustomers.executeQuery();
			resultSetTest = searchTest.executeQuery();
			resultSetVideo = searchVideo.executeQuery();
			results = new ArrayList<Customer>();			
		
			searchName(name);
			
			while (resultSet.next())
			{
	
						
					Customer c1 = new Customer(resultSet.getString("customer"),new Address(resultSet.getString("street"),resultSet.getString("city"),resultSet.getString("state"),resultSet.getInt("zipcode")),resultSet.getInt("account"));
					customerList.add(c1);
					String custtype = resultSet.getString("type");
					
					if (custtype.equals("SILVER"))
						c1.setCType(Customer.CustomerType.SILVER);
					if (custtype.equals("GOLD"))
						c1.setCType(Customer.CustomerType.GOLD);
					if (custtype.equals("PLATINUM"))
						c1.setCType(Customer.CustomerType.PLATINUM);
				
			}
			while (resultSetVideo.next())
			{
				Video v1 = new Video(resultSetVideo.getInt("chapter"), resultSetVideo.getString("title"), resultSetVideo.getInt("id"));
				for (Customer c: customerList)
				{
					if(c.getName().equals(name))
						c.addLesson(v1);
				}
			}
			
			
			while(resultSetTest.next())
			{
				Test t1 = new Test(resultSetTest.getInt("chapter"), resultSetTest.getString("title"), resultSetTest.getInt("grade"));
				for (Customer c: customerList)
				{
					if(c.getName().equals(name))
						c.addLesson(t1);
				}
			}	
				
				String message = "";
				
				for (Customer c : customerList)
				{
					if (c.getName().equals(name))
					{
						message += c.toString() + "\n";
						
						if (c.getLessons().equals(""))
						{
							message += "No lessons were entered." + "\n";
							message += "Feel free to go back and add some lessons." + "\n";
						}
						else
						{
							message += c.getLessons() + "\n";
							message += "This month's charge for "  + c.createInvoice()+ "\n";
						}
						
						JOptionPane.showMessageDialog(null, message);
						
					}
				}
			customerList.clear();
			
		}
		catch(SQLException sqlException)
		{
			sqlException.printStackTrace();
		}
		catch(NameNotFoundException nnfe)
		{
			JOptionPane.showMessageDialog(null, "The search found no results. Make sure you type the name exactly how you entered it in, entry is case sensitive ie: Smith instead of smith.");
		}
		finally
		{
			try
			{
				resultSet.close();
			}
			catch(SQLException sqlException)
			{
				sqlException.printStackTrace();
				close();
			}
		}
		
		return results;
	}
	
	class NameNotFoundException extends RuntimeException
	{
		public NameNotFoundException()
		{
			super("Unable to find customer name.");
		}
	}
	
	public void close()
	{
		try 
		{
			connection.close();
		} 
		catch ( SQLException sqlException )
		{
			sqlException.printStackTrace();
		} 
	} 
}