//David Eisenberg

import java.io.*;
import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class LessonGUI extends JFrame
{
	static ArrayList<Customer> customerList = new ArrayList<Customer>();
	private JPanel lTypePanel;	
	private JDesktopPane theDesktop;
	
	public LessonGUI()
	{
		super("Lesson GUI");
		
		theDesktop = new JDesktopPane();
		JMenuBar bar = new JMenuBar();
		
		JMenu customerMenu = new JMenu("Customer");
		JMenuItem addCustomer = new JMenuItem("Add customer");
		JMenuItem searchCustomer = new JMenuItem("Search customer");
		customerMenu.add(addCustomer);
		customerMenu.add(searchCustomer);
		
		JMenu lessonMenu = new JMenu("Lesson");
		JMenuItem addTest = new JMenuItem("Add Test");
		JMenuItem addVideo = new JMenuItem("Add Video");
		lessonMenu.add(addTest);
		lessonMenu.add(addVideo);
		
		JMenu databaseMenu = new JMenu("Database");
		JMenuItem writeDatabaseMenu = new JMenuItem("Write database");
		databaseMenu.add(writeDatabaseMenu);
		
		JMenu exitMenu = new JMenu("Exit");
		JMenuItem endProgram = new JMenuItem("End program");
		exitMenu.add(endProgram);
		
		bar.add(customerMenu);
		bar.add(lessonMenu);
		bar.add(databaseMenu);
		bar.add(exitMenu);
		
		add(theDesktop);
		setJMenuBar(bar);
		
		addCustomer.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent ae)
			{
				JInternalFrame frameAddCust = new JInternalFrame("Add Customer", true, true, true, true);
				
				AddCustomerPanel acp1 = new AddCustomerPanel();
				frameAddCust.add(acp1);
				frameAddCust.pack();
				frameAddCust.setSize(550,200);
				theDesktop.add(frameAddCust);
				frameAddCust.setVisible(true);
			}
		});
		
		searchCustomer.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent ae)
			{
				JInternalFrame frameSearch = new JInternalFrame("Search Customer", true, true, true, true);
				
				SearchCustomerPanel scp1 = new SearchCustomerPanel();
				frameSearch.add(scp1);
				frameSearch.pack();
				frameSearch.setSize(400,100);
				theDesktop.add(frameSearch);
				frameSearch.setVisible(true);
			}
		});
		
		addTest.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent ae)
			{
				JInternalFrame frameAddTest = new JInternalFrame("Add Test", true, true, true, true);
				AddTestPanel atp1 = new AddTestPanel();
				frameAddTest.add(atp1);
				frameAddTest.pack();
				frameAddTest.setSize(350,200);
				theDesktop.add(frameAddTest);
				frameAddTest.setVisible(true);
			}
		});
		
		addVideo.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent ae)
			{
				JInternalFrame frameAddVideo = new JInternalFrame("Add Video", true, true, true, true);
				AddVideoPanel avp1 = new AddVideoPanel();
				frameAddVideo.add(avp1);
				frameAddVideo.pack();
				frameAddVideo.setSize(350,200);
				theDesktop.add(frameAddVideo);
				frameAddVideo.setVisible(true);
			}
		});
		
		writeDatabaseMenu.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent ae)
			{
				DatabaseMethods dm4 = new DatabaseMethods();
				dm4.writeCustomerTable();
				System.out.println("\n");
				dm4.writeVideoTable();
				System.out.println("\n");
				dm4.writeTestTable();
				System.out.println("\n");
			}
		});
		
		endProgram.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent ae)
			{
				System.exit(0);
			}
		});
	}
}