//David Eisenberg

import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.util.*;
import java.awt.*;
import java.util.List;
import java.util.ArrayList;

public class SearchCustomerPanel extends JPanel
{
	static ArrayList<Customer> customerList = new ArrayList<Customer>();
	private JLabel labelNameForSearch;
	private JLabel labelSubmit;
	private JTextField fieldNameForSearch;
	private JButton submit;
	
	public SearchCustomerPanel()
	{	
		setLayout(new GridLayout(2,2));
		
		labelNameForSearch = new JLabel("Enter name for search");
		labelSubmit = new JLabel("Click Submit To Search");
		fieldNameForSearch = new JTextField();
		submit = new JButton("Submit");
		
		ButtonHandler1 handlerSubmit = new ButtonHandler1();
		submit.addActionListener(handlerSubmit);
		
		add(labelNameForSearch);
		add(fieldNameForSearch);
		add(labelSubmit);
		add(submit);
	}
	
	public void clearAll()
	{
		fieldNameForSearch.setText("");
		fieldNameForSearch.setEnabled(true);
		fieldNameForSearch.requestFocus();
	}
	
	public boolean checkData()
	{
		boolean input = true;
		
			if (fieldNameForSearch.getText().isEmpty())
			{
				JOptionPane.showMessageDialog(null, "Please enter a name to search for.");
				fieldNameForSearch.setText("");
				fieldNameForSearch.requestFocus();
				input = false;
			}
	
		return input;
	}
	
	class ButtonHandler1 implements ActionListener
	{
		public void actionPerformed (ActionEvent ae)
		{
			if(checkData())
			{
				if (!fieldNameForSearch.getText().isEmpty())
				{
					try
					{
						DatabaseMethods dm5 = new DatabaseMethods();
						dm5.searchDatabase(fieldNameForSearch.getText());
					}
					catch(NameNotFoundException nnfe)
					{
						JOptionPane.showMessageDialog(null, "The search found no results. Make sure you type the name exactly how you entered it in, entry is case sensitive ie: Smith instead of smith.");
					}
				}
				
				clearAll();
			}
		}				
	}
	
	class NameNotFoundException extends RuntimeException
	{
		public NameNotFoundException()
		{
			super("Unable to find customer name.");
		}
	}
	
	public boolean isInt(String s)
	{
		try
		{
			Integer.parseInt(s);
			return true;
		}
		catch(NumberFormatException nfe)
		{
			return false;
		}
	}	
}	