//David Eisenberg

import java.io.*;
import java.net.*;
import java.util.concurrent.*;
import java.util.*;

public class Server
{
	public static void main(String args[])
	{
		System.out.println("Press Ctrl + C to Exit the Program");
		
		try
		{
			ServerSocket serverSocket = new ServerSocket(8000);
			int clientNumber = 1;
			ExecutorService threadExecutor = Executors.newCachedThreadPool();

			while(true)
			{
				System.out.println("Waiting for Input from Client...");
				Socket connectClient = serverSocket.accept();
				System.out.println("Started thread for Client " + clientNumber);
				HandleClient thread = new HandleClient(connectClient,clientNumber);
				threadExecutor.execute(thread);
				clientNumber++;
			}
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}
	}
}

class HandleClient implements Runnable
{
	private Socket connection;
	private int clientNumber;
	private String s1;
	private Formatter output;
	private Scanner input;
	private StringBuilder s2;

	public HandleClient(Socket socket, int clientNumber)
	{
		connection = socket;
		this.clientNumber= clientNumber;
	}
	public void run()
	{
		try
		{
			input = new Scanner(connection.getInputStream());
			output = new Formatter(connection.getOutputStream());

			while(true)
			{
				s1 = input.nextLine();
				System.out.println("Input From Client " + clientNumber + ": " + "\n" + s1 + "\n");
				s2 = new StringBuilder(s1);
				s2.reverse();
				output.format("Your string reversed is %s and the length is %d\n", s2.toString(),s2.length());
				output.flush();
			}
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}
	}
}